$OPTION EXPLICIT
$INCLUDE "rapidq.inc"
$INCLUDE "QPrn.inc"

DIM MyPrinter AS QPrn

DECLARE SUB MainForm_OnClose

DECLARE SUB mfOpen_OnClick
Declare Sub mfFontChange_OnClick

DECLARE SUB mpPageSetup_OnClick
Declare Sub mpPrintPreview_OnClick
DECLARE SUB mpPrintDialog_OnClick
DECLARE SUB mpPrintGraphics_OnClick

DIM OpenDialog AS QOPENDIALOG
Dim FontDialog As QFontDialog

      'Necessary "Global" string variable
DIM strFilename AS STRING
Dim reFont As QFont
    reFont.Name  = "Courier New"
    reFont.Size  = 10
    reFont.Bold  = False

CREATE MainForm AS QFORM
    Caption  = " QPrn - Demo"
    Width  = 640
    Height  = 480
    Left  = (SCREEN.Width \ 2) - (MainForm.Width \ 2)
    Top   = (SCREEN.Height \ 2) - (MainForm.Height \ 2)
    OnClose  = MainForm_OnClose
    CREATE MainMenu AS QMAINMENU
        CREATE mFile AS QMENUITEM
            Caption = " File "
            CREATE mfOpen AS QMENUITEM
                Caption = "Open"
                OnClick = mfOpen_OnClick
            END CREATE
            CREATE mfLine AS QMENUITEM
                Caption = "-"
            END CREATE
            Create mpFontChange As QMenuItem
                Caption = "Font Change..."
                OnClick = mfFontChange_OnClick
            End Create
            Create mfLine2 As QMenuItem
                Caption = "-"
            End Create
            CREATE mfExit AS QMENUITEM
                Caption = "Exit"
                OnClick = MainForm_OnClose
            END CREATE
        END CREATE
        CREATE mPrint AS QMENUITEM
            Caption = " Print "
            CREATE mpPageSetup AS QMENUITEM
                Caption = "Page Setup"
                OnClick = mpPageSetup_OnClick
            END CREATE
            CREATE mpLine1 AS QMENUITEM
                Caption = "-"
            END CREATE
            Create mpPrintPreview As QMenuItem
                Caption = "Print Preview"
                OnClick = mpPrintPreview_OnClick
            End Create
            Create mpLine2 As QMenuItem
                Caption = "-"
            End Create
            CREATE mpPrintDialog AS QMENUITEM
                Caption = "Print Dialog"
                OnClick = mpPrintDialog_OnClick
            END CREATE
            CREATE mpPrintGraphics AS QMENUITEM
                Caption = "Print Graphics-Demo"
                OnClick = mpPrintGraphics_OnClick
            END CREATE
        END CREATE
    END CREATE
    CREATE RichEdit AS QRICHEDIT
        Align  = alClient
        Wordwrap = False
        ScrollBars = ssBoth
        Font.Name = "Courier New"
        Font.Size = 10
    END CREATE
END CREATE

IF MyPrinter.PrinterName = "" THEN
          'If there are no printers... disable the menus!
          'If you don't a "page fault" will occur
          'when the end-user selects one of them.
    mpPageSetup.Enabled = False
    mpPrintDialog.Enabled = False
    mPrint.Enabled = False
END IF

SetWindowLong(MainForm.Handle , GWL_HWNDPARENT , HWND_DESKTOP)
SetWindowLong(Application.Handle , GWL_HWNDPARENT , MainForm.Handle)

MyPrinter.parenthandle = MainForm.Handle 
MainForm.ShowModal

SUB MainForm_OnClose
    Application.Terminate
END SUB

SUB mfOpen_OnClick
    IF OpenDialog.Execute THEN
        strFilename = OpenDialog.FileName
        RichEdit.LoadFromFile(strFilename)
    END IF
END SUB

Sub mfFontChange_OnClick
    FontDialog.GetFont(reFont)
    If FontDialog.Execute Then
        FontDialog.SetFont(reFont)
        RichEdit.Font = reFont
    End If
End Sub

SUB mpPageSetup_OnClick
    MyPrinter.PageDialog
END SUB

Sub mpPrintPreview_OnClick
    'Calling .PrtPreview will display the Print Preview window,
    ' allowing the user to see what the printed page(s) will look like.
    ' (or to determine "which" pages (when a single range of pages) needs to be printed)
    'Parameters...
    ' handle of the form (within the same thread)
    ' handle of the richedit (a child of the form)
    MyPrinter.Title = strFilename
    MyPrinter.PrintPreview(MainForm.handle, RichEdit.handle, len(richedit.text))
End Sub

SUB mpPrintDialog_OnClick
    defint C = 0
    IF strFilename = "" THEN strFilename = "NoName"
    MyPrinter.richeditout(RichEdit , 0)       'Calculate pages'
    MyPrinter.Title = strFilename
    DEFLNG Mode = MyPrinter.PrintDialog(IIF(RichEdit.SelLength = 0 , PD_Default OR PD_noselection , 0))
    IF Mode THEN
        MyPrinter.header = "Here comes your header , Page %PAGE%"
        MyPrinter.footer = "This is  your footer , Page %PAGE%"
        FOR C = 1 TO MyPrinter.Copies      'For those printers, which won't make the copies by themselves
            MyPrinter.begindoc
            MyPrinter.richeditout(RichEdit , IIF(Mode = 1 , 3 , 1))       'Mode 3 for printing selected text, 1 for all
            MyPrinter.enddoc
        NEXT
    END IF
END SUB

SUB mpPrintGraphics_OnClick
    DEFLNG Mode = MyPrinter.PrintDialog(0)
    IF Mode THEN
    MyPrinter.Title = "Graphics-Demo"
    MyPrinter.begindoc
    MyPrinter.Font.AddStyles fsBold
    MyPrinter.Font.AddStyles fsItalic
    MyPrinter.Font.Size = 20
    MyPrinter.pensize = 15
    MyPrinter.penstyle = PS_Dashdot
    MyPrinter.brushhatch = HS_Cross
    MyPrinter.Line(MyPrinter.MarginLeftPix , MyPrinter.MarginTopPix , MyPrinter.MarginRightPix , MyPrinter.MarginTopPix , &H00FF00)
    MyPrinter.Circle(500 , 500 , 3800 , 5100 , &H00FF00 , &HFF0000)
    MyPrinter.penstyle = PS_Solid
    MyPrinter.brushhatch = HS_Solid
    MyPrinter.brushStyle=BS_Null
    MyPrinter.RoundRect(1000 , 1300 , 1200 , 1500 , 150 , 120 , &H00FF00 , &HFF0000)
    MyPrinter.brushStyle=BS_Hatched
    MyPrinter.Chord(1000 , 1600 , 1600 , 1900 , 1000 , 0 , 1500 , 1200 , &H00FF00 , &HFF0000)
    MyPrinter.FillRect(1000 , 2000 , 1200 , 2200 , &H00FF00 , &HFF0000)
    MyPrinter.BkMode=OPAQUE
    MyPrinter.TextOut(MyPrinter.MarginLeftPix , MyPrinter.MarginTopPix + 150 , "Test" , 0 , clBlue)
    MyPrinter.BkMode=Transparent
    MyPrinter.Font.DelStyles fsItalic
    MyPrinter.Font.Color = &HFF0000
    MyPrinter.TextOut(3000 , 3000 , "TestTest" , - 1 , clBlack)
    MyPrinter.BkMode=OPAQUE
    MyPrinter.TextRect(2000 , 2500 , 3000 , 2800 , " Test blabla " , DT_CENTER , clGreen , clRed)
    DIM bit AS QBITMAP
    OpenDialog.Caption = "Which Graphic to print ..."
    OpenDialog.Filter = "Bitmap-Files|*.bmp|All files|*.*"
    IF OpenDialog.Execute THEN
        bit.BMP = OpenDialog.FileName
        MyPrinter.Stretchdraw(1000 , 2300 , 1400 , 2700 , bit)
        MyPrinter.Draw(1000 , 2800 , bit)
    END IF
    MyPrinter.enddoc
    end if
END SUB


